//----------------------------------------------------------------
//
// NeuroChip NM6403, C runtime library
// 1997-1999 (c) RC Module Inc.
// setjmp.asm,
//
//----------------------------------------------------------------


global _setjmp: label;
global _longjmp: label;


begin text

// int setjmp( jmp_buf env )
<_setjmp>
    ar5 = sp;
    gr7 = [ ar5 -= 2 ];        //  
    ar5 = [ --ar5  ];     // env
    [ ar5++ ] = ar0, gr0;
    [ ar5++ ] = ar1, gr1;
    [ ar5++ ] = ar2, gr2;
    [ ar5++ ] = ar3, gr3;
    [ ar5++ ] = ar4, gr4;
    [ ar5++ ] = gr5;
    [ ar5++ ] = ar6;
    [ ar5 ]   = ar7, gr7;
    return
        with gr7 = false;

// void longjmp( jmp_buf env, int val );
<_longjmp>
    sp -= 2;

    .align;	//if false delayed goto 0;    // hide next 2 command from interrupt
    pop ar5;    // env
    pop gr7;    // val
		    // false goto 0;

.if .nm64revision == 5;
//	   ,   
//	 
//	:    call-  return-
	gr1 = pswr;
	pswr clear 1000h;
	pswr = gr1;
.endif;

    ar0, gr0 = [ ar5++ ]        with gr7--;
    ar1, gr1 = [ ar5++ ]		with gr7++;
    ar2, gr2 = [ ar5++ ]		with gr7 = gr7 + carry; //gr7=(gr7==0)?1:gr7
    ar3, gr3 = [ ar5++ ];
    ar4, gr4 = [ ar5++ ];
    gr5 = [ ar5++ ];
    ar6 = [ ar5++ ];
    sp = [ ar5++ ];
    ar5 = [ ar5 ];     // ip
    
    delayed goto ar5;
    sp -= 2;
    // goto ar5;

end text;
