//////////////////////////////////////////////////////////////////////////
//                                                                      //
// fabsf.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:07p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

#ifdef __cplusplus
extern "C" {
#endif

// fabsf --
//
//    
//
float fabsf(float f){
	unsigned int* ip = (unsigned int*)&f;
	*ip  &= 0x7fffffff;     //    
	return f;
}

#ifdef __cplusplus
}
#endif
