//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                              //
//                                                                          //
//                                               //
//                                           //
//                                                                          //
//                          i64tof.asm                                      //
//                                                                          //
//        64      //
//     32 .                                     //
// ConvI64toF -      float.                    //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

// : 
// : 02 ( 27.11.97 )
// : 
// :   2    .    
//   .    .

global ConvI64toF :label;


extern FResult :label;


begin text

//=====  ConvI64toF ==========================
//       64    
//     32 .
//    .
//  :    
//  0 = SP -       
// -1 = ArgHi -    32  ,
// -2 = ArgLo -    32  ,
// -3 = PSW
// -4 = PC
//  : gr7 -  , float 32 
// : ar5
<ConvI64toF>
        //  .  gr5.
    pop ar5,gr5 with gr7 = gr5;     // ar5 - ArgLo, gr5 - ArgHi
    push ar1,gr1 with gr1 = gr5;    // gr1 - ArgHi
    push ar4,gr4 with gr4 = gr1;    // gr4 - ArgHi
    push ar0,gr0 with gr5 = gr7 noflags;    //  gr5
    if >= delayed skip L1;
    gr0 = ar5;                      // gr0 - ArgLo
    push ar3,gr3 with gr3 = false;
    // cond. skip L1

    gr0 = -gr0;
    gr1 = gr3 - gr1 - 1 + carry;
<L1>
    push ar2, gr2;
    delayed call FResult;
    gr2 = 127 + 32 + 23;
    // call FResult;
    pop ar2, gr2;
    pop ar3,gr3;
    pop ar0,gr0;
    pop ar4,gr4;
    pop ar1,gr1;
    return;

end text;

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                        i64tof.asm                              //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
